Public Class Form1

    Private m_DataSet As New DataSet

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim table As New DataTable("Face")
        With table
            .Columns.Add("Face", GetType(String))
            .Rows.Add("A")
            .Rows.Add("B")
            .Rows.Add("C")
            .Rows.Add("D")
        End With

        Dim table2 As New DataTable("Pets")
        With table2
            .Columns.Add("Type", GetType(String))
            .Rows.Add("Dog")
            .Rows.Add("Cat")
            .Rows.Add("Fish")
            .Rows.Add("Snake")
        End With

        With m_DataSet
            .ReadXml("..\..\TestData.xml")

            With .Tables("Customers").Columns
                .Add("Face", GetType(String))
                .Add("Pet", GetType(String))
            End With

            .Tables.Add(table)
            .Tables.Add(table2)
        End With

        With Me.FpSpread1.ActiveSheet

            Dim renderer As New FarPoint.Win.Spread.CellType.ColumnHeaderRenderer
            renderer.WordWrap = False
            'For Each columnHeader As Spread.Column In .ColumnHeader.Columns
            '    .ColumnHeader.DefaultStyle.Renderer = renderer
            'Next
            .ColumnHeader.DefaultStyle.Renderer = renderer

            .DataSource = m_DataSet.Tables("Customers")

            ' Show FarPoint combo box arrows only on the current cell.
            Me.FpSpread1.ButtonDrawMode = ButtonDrawModes.CurrentCell

            Dim cb As New FarPoint.Win.Spread.CellType.MultiColumnComboBoxCellType
            With cb
                .DataSourceList = table.DefaultView
            End With
            .Columns(.ColumnCount - 2).CellType = cb

            Dim cb2 As New FarPoint.Win.Spread.CellType.MultiColumnComboBoxCellType
            With cb2
                .DataSourceList = table2.DefaultView
            End With
            .Columns(.ColumnCount - 1).CellType = cb2

            For Each column As Spread.Column In .Columns
                If column.DataField = "Face" Then
                    column.Width = Math.Max(GetWidth(m_DataSet.Tables("Face")), column.GetPreferredWidth)
                ElseIf column.DataField = "Pet" Then
                    column.Width = Math.Max(GetWidth(m_DataSet.Tables("Pets")), column.GetPreferredWidth)
                Else
                    column.Width = column.GetPreferredWidth
                End If
            Next

        End With
    End Sub

    Private Function GetWidth(ByVal table As DataTable) As Integer
        Dim g As Graphics = Me.CreateGraphics
        Dim font As New Font(Me.Font, FontStyle.Regular)
        Try
            Dim maxWidth As Single = Single.MinValue
            For Each row As DataRow In table.Rows
                Dim width As Single = g.MeasureString(row(0).ToString, font).Width
                If width > maxWidth Then
                    maxWidth = width
                End If
            Next
            ' Include width of DropDownArrow
            Return Convert.ToInt32(Math.Round(maxWidth)) + SystemInformation.VerticalScrollBarWidth + 1
        Catch ex As Exception
            Throw
        Finally
            If g IsNot Nothing Then g.Dispose()
            If font IsNot Nothing Then font.Dispose()
        End Try
    End Function 'GetWidth

End Class
